function [indices, indices_off] = find_indices(obj, data)
% FIND INDICES - looks for the indices that are above TAG_THRESHOLD

    try

        indices = [];
        indices_off = [];
        
        %% DO CHECKS & run transform_function()
        transformed_data = find_indices_pre(obj, data);
        if obj.testok == obj.PLUGIN_TEST_FAILED
            return;
        end
        
        %% find the crossings
        [indices, indices_off] = plugin_tag_find_indices(obj, transformed_data);

        %% DO ALL CHECKS
        
        if isempty(indices_off) && size(indices, 2) == size(transformed_data, 2)
            disp('No off-threshold crossings detected. All data is above threshold. You probably used a wrong threshold.');
            obj.TAG_QUIT = 1;
        end

        if max(indices_off) < max(indices)
            indices_off(end+1) = length(transformed_data);
        end
        
        %% check if indices are found.
        if size(indices, 1) == 0 || isempty(indices)
            obj.TAG_QUIT = 1;
            disp('No on-threshold crossings detected.');
        end

    %%
    catch me
        obj.show_error(me.message, mfilename, me.stack, obj.Name, 'find_indices()', me.identifier);
        obj.TAG_QUIT = 1;
    end

end
%% EOF
