function obj = loadobj(S)
% load method for fb_abstract.tag object

    %% check for old cases where the entire object got saved
    if isobject(S)
        obj = S;
        return;
    end

    %% object was saved with custom written saveobj() method
    
    % Construct the original class
    obj = eval(S.ORIGINAL_PLUGIN_CLASS);
    
    % get list of save fieldnames and write values back to object
    props = fieldnames(S);
    
    % write back the saved TAG settings to the object
    for i = 1 : size(props, 1)
        
        % ignore this field because it's not a property we want to restore
        if strcmp(props{i}, 'ORIGINAL_PLUGIN_CLASS')
            continue;
        end
        
        obj.(props{i}) = S.(props{i});
        
    end
    
    %% overwrite individual properties
    
    % needs to be zero so that obj.demo() works again. see
    % fb_abstract.tag.plugin_tag_plot()
    obj.TAG_RAW_OUTPUT_SETUP = 0;
    
end
%% EOF
