function remove_overlapping_indices(obj)
% REMOVE OVERLAPPING INDICES

    %% don't do anything if user didn't define a non-zero value
    if obj.TAG_SAMPLES_BETWEEN_INDICES == 0
        return;
    end

    %% otherwise
    offset = obj.TAG_SAMPLES_BETWEEN_INDICES;
    ind_cpy = obj.TAG_INDICES;
    
    % start with the first index
    i = 1;
    % array to hold indices that need to be removed.
    all_remove = [];
    
    while i < size(ind_cpy, 2)
        
        this_value = ind_cpy(i);
        
        % look for all values that are smaller then the current
        % value + offset. exclude the current value and start the
        % search with the following value.
        to_remove = find(ind_cpy(i + 1:end) <= this_value + offset);
        
        % next iteration if none found. Go to next index.
        if isempty(to_remove)
            i = i + 1;
            continue;
        end
        
        % add index offset.
        to_remove = to_remove + i;
        all_remove = [all_remove to_remove];
        
        % move i to first index after the last one of to be removed
        % indices.
        i = to_remove(end) + 1;
        
    end
    
    if isempty(all_remove)
        return;
    end
    
    obj.TAG_INDICES(all_remove) = [];
    obj.TAG_INDICES_OFF(all_remove) = [];

end
%% EOF
