function transform_indices(obj, indices, indices_off)
% TRANSFORM INDICES into SAMPLES

    % If indices_on_orig or indices_off_orig is empty, then this function
    % will never be called. See fb_abstract.tag.plugin_tag_function()
    
    %% CONVERT INDICES INTO SAMPLES, according to the 'PLOT_TYPE'
    % i.e, if PLOT_TYPE is in samples, don't do anything.
    % i.e, if PLOT_TYPE is in buffers, we need to convert to samples.
    switch obj.PLOT_TYPE
        case 1
            obj.TAG_INDICES = indices;
            obj.TAG_INDICES_OFF = indices_off;
            
        case {2, 3}
            obj.TAG_INDICES = obj.transfer_single_buffer_to_sample(indices);
            obj.TAG_INDICES_OFF = obj.transfer_single_buffer_to_sample(indices_off);
            
        otherwise
            obj.TAG_QUIT = 1;
            disp('aborting in: transform_indices()');
            disp('tagging not implemented yet for this "PLOT_TYPE".');
    end
    
end
%% EOF
