function [Result Param] = ConvertCurrentDirLVDtoArray(Param)
tic
AA = single([]);
Sync = uint8([]);  %single - for further rescaling - later
Threshold = 2000;   %for synchronizatrion in ADC counts, max 4000 = appr. 0.6V, +/-5V input range 10bit ADC
files  = dir([Param.StartDir filesep '*.lvd']);
for I_t = 1:size(files,1)
  filenameA = files(I_t).name;   
  fi=fopen([Param.StartDir filesep filenameA],'r','ieee-be');
  par=fread(fi,4,'double');
  yA=fread(fi,[par(2) inf],'*int16');
  fclose(fi);
  St = uint8(yA(2,:)>Threshold);
  Sync = [Sync St];   %second channel - synchronization
  if Param.Playback
    yA=single(yA([Param.MicChannel Param.PlaybackChannel],:));
  else
    yA=single(yA([Param.MicChannel],:));  
  end    
  %yA=single(yA(Param.channel,:))*single(par(4))/2^15;   %will be in Volts - bad idea, should be left in counts
  AA = [AA yA];  
  disp([int2str(I_t),' ',filenameA]);
  if I_t==1
    p = strfind(filenameA,'U-');
    Param.AnimalName = filenameA(1:(p-1));
    %disp(AnimalName);
    FileStartTimeSt = num2str(par(3),'%017.3f');
    Param.FileStartTime = datenum(FileStartTimeSt,'yyyymmddHHMMSS.FFF');
  end    
end

AA = AA';
Sync = Sync';

%now we need to rescale arrays from 32000 to 19200 Hz - don't do!
AA=AA-repmat(mean(AA),length(Sync),1); %remove constant bias  
% if par(1)~=Param.scanrateDesired
%   N=floor(length(Sync)/par(1)*Param.scanrateDesired);%par(1) - Param.scanrateLVD
%   AA=interpft(AA,N);
%   Sync = uint8(interpft(Sync,N)>0.5);
% end

Result.C = AA;
Result.Sync = Sync;
clear AA Sync
toc