%Name = 'g5p5_03022014_t070000';
tic
%Ext = 'm';
%load(Name);

%for debugging only take small amount of the record at the beginning
%B((1e7+1):end,:) = [];  %take 8.68 minutes
%Sync((1e7+1):end) = [];
disp(['Samples: ' num2str(length(Sync))]);

%figure(1); clf; plot(B(end-(5e5:-1:0)-1e6,:));
%sequence of channels: sound strong amplification, sound weak
%amplification, acceleration strong amplification, acceleration weak
%acceleration
srate = 19200;


pnts = srate*15;    %15 seconds to calculate mean and variance, take from the middle of the record
%compute means for each full frame
NFrames = floor(length(Sync)/pnts);
C = B;  %uint16
Crem = rem(size(C,1),pnts)-1;
if (Crem>-1)
  C((size(C,1)-Crem):size(C,1),:) = [];
end;    
C = reshape(C,pnts,NFrames,4);  %288000, 620, 4

Q = 0.01;   % 1% from range, about 25 steps, the midline has guaranteed accuracy of 1%
RangePlusHi = 1024+512*(1-Q); %mean is 1024, but range is from 512 to 1024+512
RangeMinusHi = 512*(1+Q);     

Cm = zeros(1,size(C,2),4);
ArrayMask = (C>RangeMinusHi)&(C<RangePlusHi);
for I_t = 1:size(ArrayMask,2)
  for J_t = 1:4  
    Cm(1,I_t,J_t) = mean(C(ArrayMask(:,I_t,J_t),I_t,J_t)); %was mean before 28.02.2014, but median does not help
  end
end    %4.2 seconds
Cmm = repmat(Cm,size(C,1),1);
Q1 = 0.10;  %10 percent out, tried 5%, but did not help in one case, 1% good for 2013-12-11playback!!!
ArrayMask1 = (C>Cmm+Q1*512)|(C<Cmm-Q1*512);
ArrayMask2 = ArrayMask & ArrayMask1;

C_minus_mean = C-Cmm;
clear Cmm

%RangePlusLow = Cm+512*Q;
%RangeMinusLow = Cm-512*Q;
%Counters = [0 0];
%matlabpool open
%tic
Sums = zeros(size(C,2),4); %620x4
for K_t = 1:size(C,2)   %was par
  MySum = zeros(1,4);
  P_minus_mean0 = squeeze(C_minus_mean(:,K_t,:));
for I_t = 1:size(C,1)    
  P_minus_mean = P_minus_mean0(I_t,:);
  if ArrayMask2(I_t,K_t,1)
    MySum(1,[1 2]) = MySum(1,[1 2])+abs(P_minus_mean([1 2]));
  end
  if ArrayMask2(I_t,K_t,3)
    MySum(1,[3 4]) = MySum(1,[3 4])+abs(P_minus_mean([3 4]));
  end     
end
Sums(K_t,:) = MySum(1,:) ;
end
%toc %98 seconds
%matlabpool close
clear ArrayMask ArrayMask1 ArrayMask2 C_minus_mean P_minus_mean0

K = Sums(:,[1 3])./Sums(:,[2 4]);
%disp(K);  %620, 2
%correct low amplification channels
%tic
B_minus_mean = B;
for I_t = 1:size(C,2)
  L = pnts*(I_t-1)+(1:pnts);
  %if ~isnan(K(I_t,1))
    B_minus_mean(L,2) = (B(L,2)-Cm(1,I_t,2))*K(I_t,1)+Cm(1,I_t,1);
  %end
  %if ~isnan(K(I_t,2))
    B_minus_mean(L,4) = (B(L,4)-Cm(1,I_t,4))*K(I_t,2)+Cm(1,I_t,3);
  %end
end
clear L
%toc 7.3 seconds
%correct the tail
if (Crem>-1)
  L = (pnts*size(C,2)+1):size(B,1);
  %if ~isnan(K(end,1))
    B_minus_mean(L,2) = (B(L,2)-Cm(1,end,2))*K(end,1)+Cm(1,end,1);
  %end
  %if ~isnan(K(end,2))
    B_minus_mean(L,4) = (B(L,4)-Cm(1,end,4))*K(end,2)+Cm(1,end,3);
  %end  
end;
clear L Cm
%figure(2); clf; plot(B_minus_mean(round(end*0.2)+(1:pnts),:));
%figure(3); clf; plot(B_minus_mean(round((end-pnts)*0.5)+(1:pnts),:));
%figure(4); clf; plot(B_minus_mean(round(end*0.8)-(pnts:-1:1),:));
%correction is good!
%%
%combine two records replacing cutted values by low-resolution values
%tic
P = B(:,1);
V = (P<=RangeMinusHi)|(P>=RangePlusHi);
B_minus_mean(V,1) = B_minus_mean(V,2);
P = B(:,3);
V = (P<=RangeMinusHi)|(P>=RangePlusHi);
B_minus_mean(V,3) = B_minus_mean(V,4);
clear P V B %temporarily removed delete
%toc %2.9 seconds
% %tic
% for I_t = 1:size(B,1)
%   P = B(I_t,1:4);
%   if (P(1)<=RangeMinusHi)||(P(1)>=RangePlusHi)   
%     B_minus_mean(I_t,1) = B_minus_mean(I_t,2);
%   end
%   if (P(3)<=RangeMinusHi)||(P(3)>=RangePlusHi) 
%     B_minus_mean(I_t,3) = B_minus_mean(I_t,4);
%   end   
% end 
% %toc 304.4 seconds!!!
%figure(5); clf; plot(B_minus_mean(1e6+(1:5e5),:));
C = B_minus_mean(:,[1 3]);  %here we have mean about 512(?)!!!
clear B_minus_mean P_minus_mean
toc
%figure(6); clf; plot(C(1e6+(1:5e5),:));
%tic
%save([Param.StartDir filesep Name '_C'],'C','Sync','-v7.3');
%toc  %61.8 seconds

