function [ CorrespondingPoints Deviations ] = GetCorrespondingPoints( NI, BP, Param )
%UNTITLED4 Summary of this function goes here
%   Detailed explanation goes here

%Now compute shifts in equal intervals starting from synchronization point
%Each comparison will save the corresponding points
NFiles = 2;
BestAnimal = Param.BestAnimal; %take backpack as reference (not sure that this is a good idea - one has to check)
SyncA = cell(NFiles,1);
SyncA{1} = NI.Sync;
SyncA{2} = BP.Sync;
MyStarts = [NI.Start_count BP.Start_count];
%get length
clear L LS
L = [length(NI.Sync) length(BP.Sync)]; 
LS = L-MyStarts+1;
[minLS ShortestRecID] = min(LS);

NPoints = floor((minLS-(Param.SynchronizationFrame+Param.MaxShiftAllowed))/Param.SynchronizationLag)+1;
CorrespondingPoints = zeros(NPoints,NFiles);
CorrespondingPoints(1,:) = MyStarts;
A_longA = zeros(Param.SynchronizationFrame+2*Param.MaxShiftAllowed,NFiles,'uint8');
Shifts = zeros(1,NFiles);
Error = false;
NGPUs = gpuDeviceCount;
if NGPUs<Param.MyGPU
 GPUt = NGPUs;
else
 GPUt = Param.MyGPU;  
end
if GPUt>0
  GPU = true;
else
  GPU = false;  
end   

AG = zeros(1,NFiles);
GCounter = 0;
for I_t = 1:NFiles
  if I_t~=BestAnimal
%     if GCounter<NGPUs
%       GCounter = GCounter+1; 
%     else
%       GCounter = 1;  
%     end
    AG(I_t) = GPUt; %GCounter;
  end    
end    
%matlabpool;%(NGPUs); one comparison - no need!
tic
for I_t = 2:NPoints %2
    %the following is just to verify that all arrays under comparison are
    %not arrays filled with zeros
    b = 0; c = 0;
    NextPoint = CorrespondingPoints(I_t-1,:)+Param.SynchronizationLag;
    while c<Param.Threshold
      while b<Param.Threshold 
         if NextPoint(BestAnimal)+Param.SynchronizationFrame-1<=L(BestAnimal)    
           A_short = SyncA{BestAnimal}(NextPoint(BestAnimal)+(1:Param.SynchronizationFrame)-1);
         else
           Error = true;
           break
         end    
         b = sum(A_short);
         if b<Param.Threshold 
           NextPoint = NextPoint+Param.SynchronizationFrame;  
         end    
      end    
      for J_t = 1:NFiles
        if J_t~=BestAnimal  
          if NextPoint(J_t)+Param.SynchronizationFrame+Param.MaxShiftAllowed-1<=L(J_t)   
            A_longA(:,J_t) = SyncA{J_t}(NextPoint(J_t)+((-Param.MaxShiftAllowed+1):(Param.SynchronizationFrame+Param.MaxShiftAllowed))-1);
          else
            Error = true;
            break
          end    
        end
      end 
      if Error
        CorrespondingPoints(I_t:end,:) = [];
        NPoints = I_t-1;
        break  
      end    
      c0 = sum(A_longA);
      c0(BestAnimal) = [];  %don't include it as shift is not done
      c = min(c0);
      if c<Param.Threshold  
        NextPoint = NextPoint+Param.SynchronizationFrame;    
      end    
    end
    if Error
      break  
    end    
    %here we can take these arrays for processing...
    for J_t = 1:NFiles    %parfor - no need for one comparison
      if J_t~=BestAnimal
        if GPU; gpuDevice(AG(J_t)); end
        Shifts(J_t) = GetShiftsG(A_short,A_longA(:,J_t),GPU)-Param.MaxShiftAllowed;  
      end
    end
    CorrespondingPoints(I_t,:) = NextPoint+Shifts;
    disp(num2str(I_t-1));
end
toc
%matlabpool close - no need for one comparison
%
%Subtruct start
CP_tmp = CorrespondingPoints-repmat(CorrespondingPoints(1,:),size(CorrespondingPoints,1),1);
Deviations = CP_tmp;
for I_t = 1:NFiles
  Deviations(:,I_t) = CP_tmp(:,I_t)-CP_tmp(:,BestAnimal);  
end 

scrsz = get(0,'ScreenSize');
f2 = figure(2); clf;
set(f2,'Position',[1 scrsz(4)-900-70 1440 900]);
Xmax = minLS/Param.scanrateMax/3600;
line([0 Xmax],[0 0],'linestyle',':','color','k');
hold on
X = CP_tmp(:,BestAnimal)/Param.scanrateMax/3600;
Y = Deviations(:,2)*1000/Param.scanrateMax;
plot(X,Y,'b');
plot(X,Y,'.r');
xlabel('Time (h)');
ylabel('Clock drift (ms)');
xlim([0 Xmax]);
box off;
title(Param.Name,'interpreter','none');

NameTmp = [Param.StartDir filesep Param.Name '_Drift'];
%saveas(f2,NameTmp,'fig'); 
saveas(f2,NameTmp,'emf');
end

