function [ output_args ] = SimpleViewer( varargin )
%UNTITLED Summary of this function goes here
%   the number of file to view can be given, if not - assume 1
if length(varargin)==1
  FileNumber = varargin{1};
else
  FileNumber = 1;
end  
    
FNameBase = 'g2k8U-f';
%DataDir = 'Data\2013-12-13_WallMic_19200';
DataDir = 'Data\2013-12-13_HeadMic_19200';
CurrentDirectory = pwd;
FName = [FNameBase sprintf('%05d',FileNumber) '.lvd'];
Name_tmp = [CurrentDirectory filesep DataDir filesep FName];
fi=fopen(Name_tmp,'r','ieee-be');
par=fread(fi,4,'double');
yA=fread(fi,[par(2) inf],'*int16');
fclose(fi);
FileStartTimeSt = num2str(par(3),'%017.3f');
FileStartTime = datenum(FileStartTimeSt,'yyyymmddHHMMSS.FFF');
DSt = datestr(FileStartTime, 'mmm dd, yyyy HH:MM:SS.FFF');

scrsz = get(0,'ScreenSize');
f1 = figure(1); clf;
set(f1,'Position',[1 45 scrsz(3) scrsz(4)-125]);
set(f1,'name',[Name_tmp ' - ' DSt]);

subplot(4,1,1);%wall microphone
Param.channel = 1;
Scale = 5;
yAt=par(4)*double(yA(Param.channel,:))/(2^15);
song_tmp=yAt-mean(yAt);
specgram1(song_tmp*Scale,[],par(1));
ylim([0 9600]);
xlabel('Time, sec');
ylabel('Frequency, Hz');
title('Wall microphone');

subplot(4,1,2);%head microphone
Param.channel = 2;
Scale = 25;
yAt=par(4)*double(yA(Param.channel,:))/(2^15);
song_tmp=yAt-mean(yAt);
specgram1(song_tmp*Scale,[],par(1));
ylim([0 9600]);
xlabel('Time, sec');
ylabel('Frequency, Hz');
title('Backpack microphone');

subplot(4,1,3);%accelerometer
Param.channel = 3;
Scale = 50;
yAt=par(4)*double(yA(Param.channel,:))/(2^15);
song_tmp=yAt-mean(yAt);
specgram1(song_tmp*Scale,[],par(1));
ylim([0 9600]);
xlabel('Time, sec');
ylabel('Frequency, Hz');
title('Accelerometer');

subplot(4,1,4);%accelerometer
Param.channel = 4;
Scale = 50;
yAt=double(yA(Param.channel,:));
X = (1:length(yAt))/19200;
plot(X,yAt,'r');
hold on
% Param.channel = 5;
% yAt=double(yA(Param.channel,:));
% X = (1:length(yAt))/19200;
% plot(X,yAt-1,'b');
ylim([-0.050 1.05]);
xlim([X(1) X(end)]);
xlabel('Time, sec');
ylabel('Level');
title('Vocalization detection');

end

